VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Anchor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Anchors
' Class: Anchor
' By neophile (n_e_o_p_h_i_l_e@yahoo.com)
' 5/28/2002
' -----------------------------------------------
' MODIFIED JANUARY 2006 TO ALLOW FOR DIFFERENT ANCHOR TYPES
' JEFF JENNESS (jeffj@jennessent.com)
'

Option Explicit

Public Enum AnchorTypes
   enumNone        ' Avenue Fastener ( - , - , - )
   enumStart       ' Avenue Fastener (Left/Top, - , - )
   enumStartSize   ' Avenue Fastener (Left/Top, Width/Height, - )
   enumStartEnd    ' Avenue Fastener (Left/Top, - , Right/Bottom )
   enumSize        ' Avenue Fastener ( - , Width/Height, - )
   enumSizeEnd     ' Avenue Fastener ( - , Width/Height, Right/Bottom)
   enumEnd         ' Avenue Fastener ( - , - , Right/Bottom)
   
   'atPosition  ' Anchor position (Left/Top)
   'atSize      ' Anchor size (Width/Height)
End Enum


Public AnchorType As AnchorTypes  ' Anchor type

Public MinValue As Long  ' Minimum value

Public MaxValue As Long  ' Maximum value

Public Value As Single  ' Relative distance


Private Sub Class_Initialize()
36:    MinValue = -&H7FFFFFFF  ' Set to max lower limit
37:    MaxValue = &H7FFFFFFF  ' Set to max upper limit
End Sub

