VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsExportCS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_pApp As IApplication
Private m_bitmap As IPictureDisp
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pThisExt As Brad_Convert.clsExtension

Implements ICommand
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\test_graph_form\clsCrossTab.cls"

 
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler

15:   Set m_bitmap = LoadResPicture(102, vbResBitmap)

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler

25:   Set m_bitmap = Nothing
26:   Set m_pApp = Nothing
27:   Set m_pThisExt = Nothing
28:   Set m_pMxDoc = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler

38:   ICommand_Enabled = True

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
50:    ICommand_Checked = False


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
63:   ICommand_Name = "BradExport_ExportToCS"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
76:   ICommand_Caption = "Export Rasters to Circuitscape"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
89:   ICommand_Tooltip = "Export to Circuitscape"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
102:   ICommand_Message = "Export multiple rasters to Circuitscape, using projection, extent and cell size of template raster..."


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
115:   ICommand_HelpFile = ""


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
128:   ICommand_HelpContextID = 0


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
141:   ICommand_Bitmap = m_bitmap.Handle


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
154:   ICommand_Category = "Circuitscape Tools"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler


166:   Set m_pApp = hook
167:   Set m_pMxDoc = m_pApp.Document
  Dim newUid As New UID
  Dim pExt As IExtension
170:   newUid.Value = "Brad_Convert.clsExtension"
171:   Set pExt = m_pApp.FindExtensionByCLSID(newUid)
172:   Set m_pThisExt = pExt

  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler

'  MsgBox "About to run clsExportCS..."
  
  Dim pVarArray As esriSystem.IVariantArray
186:   Set pVarArray = New VarArray

  ' ADD APPLICATION, EXTENSION, MXDOC
189:   pVarArray.Add m_pApp
190:   pVarArray.Add m_pThisExt
191:   pVarArray.Add m_pMxDoc

  Dim pForm As Brad_Convert.frmRasterExportLayerID
194:   Set pForm = New Brad_Convert.frmRasterExportLayerID
195:   Set pForm.ArcApplication = pVarArray
196:   pForm.Show vbModal
197:   Set pForm = Nothing

199:   If m_pThisExt.ShouldContinue = False Then
200:   '  MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
    Exit Sub
202:   End If

  Dim pReturnArray As esriSystem.IVariantArray
205:   Set pReturnArray = m_pThisExt.frmRasterExportLayerIDReturn

  Dim strReport As String
208:   strReport = Brad_Convert.CircScapeFunctions.ExportRastersToAscii(pVarArray, pReturnArray)
  
  Dim frmReportForm As Brad_Convert.frmReportDialog
211:   Set frmReportForm = New Brad_Convert.frmReportDialog
  
  ' SHOW NORMAL TEXT REPORT
214:   frmReportForm.txtReport.TextRTF = strReport
215:   frmReportForm.txtReport.Locked = False
216:   frmReportForm.Caption = "Circuitscape Export Complete:"
217:   frmReportForm.Show vbModal
  
  ' CLEAR MEMORY
220:   Set frmReportForm = Nothing
221:   Set m_pThisExt.frmRasterExportLayerIDReturn = Nothing
222:   Set pVarArray = Nothing
  
  Dim pDirty As IDocumentDirty
225:   Set pDirty = m_pMxDoc
226:   pDirty.SetDirty
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub





