VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form frmReportDialog 
   Caption         =   " Report"
   ClientHeight    =   3075
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8685
   Icon            =   "frmReportDialog.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3075
   ScaleWidth      =   8685
   StartUpPosition =   1  'CenterOwner
   Begin RichTextLib.RichTextBox txtReport 
      Height          =   2475
      Left            =   180
      TabIndex        =   3
      Top             =   120
      Width           =   8430
      _ExtentX        =   14870
      _ExtentY        =   4366
      _Version        =   393217
      BorderStyle     =   0
      Enabled         =   -1  'True
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      Appearance      =   0
      TextRTF         =   $"frmReportDialog.frx":0E42
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&Exit"
      Default         =   -1  'True
      Height          =   345
      Left            =   5194
      TabIndex        =   0
      Top             =   2730
      Width           =   1395
   End
   Begin VB.CommandButton cmdPrint 
      Caption         =   "&Print"
      Height          =   345
      Left            =   2085
      TabIndex        =   1
      Top             =   2730
      Width           =   1395
   End
   Begin VB.CommandButton cmdCopy 
      Caption         =   "&Copy to Clipboard"
      Height          =   345
      Left            =   3514
      TabIndex        =   2
      Top             =   2730
      Width           =   1665
   End
   Begin VB.TextBox txtBackground 
      Height          =   2670
      Left            =   30
      Locked          =   -1  'True
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   15
      Width           =   8640
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   225
      Top             =   2475
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   8460
      Picture         =   "frmReportDialog.frx":0EC4
      Top             =   2850
      Width           =   225
   End
End
Attribute VB_Name = "frmReportDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Anchors As AnchorObjectList  ' Main anchor control object
Private Const AnInch As Long = 1440   '1440 twips per inch
Private Const QuarterInch As Long = 360

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Type CharRange
  cpMin As Long     ' First character of range (0 for start of doc)
  cpMax As Long     ' Last character of range (-1 for end of doc)
End Type

Private Type FormatRange
  hdc As Long       ' Actual DC to draw on
  hdcTarget As Long ' Target DC for determining text formatting
  rc As RECT        ' Region of the DC to draw to (in twips)
  rcPage As RECT    ' Region of the entire DC (page size) (in twips)
  chrg As CharRange ' Range of text to draw (see above declaration)
End Type

Private Const WM_USER As Long = &H400
Private Const EM_FORMATRANGE As Long = WM_USER + 57
Private Const EM_SETTARGETDEVICE As Long = WM_USER + 72
Private Const PHYSICALOFFSETX As Long = 112
Private Const PHYSICALOFFSETY As Long = 113

Private Declare Function GetDeviceCaps Lib "gdi32" ( _
   ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
   (ByVal hWnd As Long, ByVal msg As Long, ByVal wp As Long, _
   lp As Any) As Long
Private Declare Function CreateDC Lib "gdi32" Alias "CreateDCA" _
   (ByVal lpDriverName As String, ByVal lpDeviceName As String, _
   ByVal lpOutput As Long, ByVal lpInitData As Long) As Long
   
Option Explicit
Const c_sModuleFileName As String = "...FORM = frmReportDialog.frm"

Private Sub cmdCopy_Click()
  On Error GoTo ErrorHandler

'    Clipboard.Clear
'    Clipboard.SetText (txtReport.Text)
'    cmdOK.SetFocus
  
  Dim strText As String
52:   strText = txtReport.TextRTF
53:   Clipboard.Clear
54:   Clipboard.SetText txtReport.Text
  
56:   If Left(strText, 5) = "{\rtf" Then
57:     Clipboard.SetText txtReport.TextRTF, vbCFRTF
58:   Else
59:     Clipboard.SetText txtReport.Text
60:   End If
61:   cmdOK.SetFocus
    
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCopy_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler


72:   Unload Me


  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Private Sub cmdPrint_Click()
  On Error GoTo ErrHand

'   Dim sinOutMemo As Single           ' Single:  used to break up strComments
'   Dim sinLenOutMemo As Single        ' Single:  used to mark length of strComments
'   Dim strPrintOutMemo As String      ' Printer input memo string
'
''~~~~~~~~~~This section formats the definitions for the printer, by breaking the definition
''          up into printer-sized strings and sticking "vbNewLines" between them.  It also
''          searches for spaces to make the breaks at.
'
'
'    strPrintOutMemo = txtReport.Text
'    sinLenOutMemo = Len(strPrintOutMemo)
'
'    Dim sinTestNum As Long
'    sinTestNum = InStr(1, strPrintOutMemo, vbNewLine)
'    If (sinTestNum < 70) And (sinTestNum <> 0) Then
'      sinOutMemo = sinTestNum
'    Else
'      sinOutMemo = 70
'    End If
'
'    Dim theDecreaseInc As Long
'
'    Do While sinLenOutMemo > sinOutMemo
'        sinTestNum = InStr(sinOutMemo, strPrintOutMemo, vbNewLine)
'        If sinTestNum < (sinOutMemo + 70) And sinTestNum <> 0 Then
'          sinOutMemo = InStr(sinOutMemo, strPrintOutMemo, vbNewLine) + 1
'        Else
'          sinOutMemo = sinOutMemo + 70
'          theDecreaseInc = 70
'          Do While InStr(sinOutMemo, strPrintOutMemo, " ") <> sinOutMemo And InStr(sinOutMemo, strPrintOutMemo, "-") <> sinOutMemo
'              sinOutMemo = sinOutMemo - 1
'              theDecreaseInc = theDecreaseInc - 1
'              If theDecreaseInc = 0 Then
'                sinOutMemo = sinOutMemo + 70
'                Exit Do
'              End If
'          Loop
'          strPrintOutMemo = Left(strPrintOutMemo, sinOutMemo) & vbNewLine & Mid(strPrintOutMemo, sinOutMemo + 1)
'        End If
'    Loop
'
'
'    Printer.FontSize = 12
'    Printer.Print strPrintOutMemo
'    Printer.Print
'    Printer.EndDoc
'
'cmdOK.SetFocus
132:   CommonDialog1.PrinterDefault = True
133:   CommonDialog1.CancelError = True
134:   CommonDialog1.ShowPrinter
  On Error Resume Next
136:   If err Then
      ' This code runs if the dialog was cancelled
'      MsgBox "Dialog Cancelled"
      Exit Sub
140:   End If
  
'  MsgBox Printer.DeviceName
  
144:   PrintRTF txtReport, AnInch, AnInch, AnInch, AnInch
145:   cmdOK.SetFocus

  Exit Sub
ErrHand:
  
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler

155:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
156:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
157:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
  Dim lngTopBar As Long
159:   lngTopBar = Me.Height - Me.ScaleHeight
160:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar
161:   Set Anchors = New AnchorObjectList  ' Create new instance
162:    With Anchors
163:       With .Item(txtBackground)
164:          .SetAnchors enumStartEnd, enumStartEnd
165:       End With
166:       With .Item(txtReport)
167:          .SetAnchors enumStartEnd, enumStartEnd
168:       End With
169:       With .Item(cmdOK)
170:          .SetAnchors enumNone, enumSizeEnd
171:       End With
172:       With .Item(cmdCopy)
173:          .SetAnchors enumNone, enumSizeEnd
174:       End With
175:       With .Item(cmdPrint)
176:          .SetAnchors enumNone, enumSizeEnd
177:       End With
178:       With .Item(imgCornerBars)
179:          .SetAnchors enumSizeEnd, enumSizeEnd
180:       End With
181:       .Form = Me  ' Set form reference (suggested to be last step)
182:    End With

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Resize()
  On Error GoTo ErrorHandler

'Move objects according to new object size.

'Dim theFrmHeight As Long
'Dim theFrmWidth As Long
'theFrmHeight = Me.Height
'theFrmWidth = Me.Width
'
'
''Debug.Print "Height = " & theFrmHeight & ",   Width = " & theFrmWidth
'
'
''If pWindowPosition.Top < 3000 And theFrmHeight > 2600 Then
'
'If theFrmWidth > 2000 And theFrmHeight > 2600 Then
'    txtBackground.Height = theFrmHeight - 915
'    txtBackground.Width = theFrmWidth - 195
'    txtReport.Height = theFrmHeight - 1125
'    txtReport.Width = theFrmWidth - 390
'    cmdOK.Top = theFrmHeight - 840
'    cmdCopy.Top = theFrmHeight - 840
'    cmdPrint.Top = theFrmHeight - 840
'    imgCornerBars.Top = theFrmHeight - 630
'    imgCornerBars.Left = theFrmWidth - 345
'End If

'If frmOutDefinition.Top < 45000 And frmOutDefinition.Height > 2600 Then
'    txtBackground.Height = frmOutDefinition.Height - 915
'    txtBackground.Width = frmOutDefinition.Width - 195
'    txtDefinition.Height = frmOutDefinition.Height - 1125
'    txtDefinition.Width = frmOutDefinition.Width - 390
'    cmdOK.Top = frmOutDefinition.Height - 840
'    cmdOK.Left = frmOutDefinition.Width - 1905
'    cmdCopy.Top = frmOutDefinition.Height - 840
'    cmdCopy.Left = frmOutDefinition.Width - 3578
'    cmdPrint.Top = frmOutDefinition.Height - 840
'    cmdPrint.Left = frmOutDefinition.Width - 5265
'End If


  Exit Sub
ErrorHandler:
  HandleError True, "Form_Resize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' WYSIWYG_RTF - Sets an RTF control to display itself the same as it
'               would print on the default printer
'
' RTF - A RichTextBox control to set for WYSIWYG display.
'
' LeftMarginWidth - Width of desired left margin in twips
'
' RightMarginWidth - Width of desired right margin in twips
'
' Returns - The length of a line on the printer in twips
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub WYSIWYG_RTF(RTF As RichTextBox, LeftMarginWidth As Long, RightMarginWidth As Long, TopMarginWidth As Long, BottomMarginWidth As Long, PrintableWidth As Long, PrintableHeight As Long)
  On Error GoTo ErrorHandler

   Dim LeftOffset As Long
   Dim LeftMargin As Long
   Dim RightMargin As Long
   Dim TopOffset As Long
   Dim TopMargin As Long
   Dim BottomMargin As Long
   Dim PrinterhDC As Long
   Dim r As Long

261:    Printer.ScaleMode = vbTwips
   
   ' Get the left offset to the printable area on the page in twips
264:    LeftOffset = GetDeviceCaps(Printer.hdc, PHYSICALOFFSETX)
265:    LeftOffset = Printer.ScaleX(LeftOffset, vbPixels, vbTwips)
   
   ' Calculate the Left, and Right margins
268:    LeftMargin = LeftMarginWidth - LeftOffset
269:    RightMargin = (Printer.Width - RightMarginWidth) - LeftOffset
   
   ' Calculate the line width
272:    PrintableWidth = RightMargin - LeftMargin
   
   ' Get the top offset to the printable area on the page in twips
275:    TopOffset = GetDeviceCaps(Printer.hdc, PHYSICALOFFSETY)
276:    TopOffset = Printer.ScaleX(TopOffset, vbPixels, vbTwips)
   
   ' Calculate the Left, and Right margins
279:    TopMargin = TopMarginWidth - TopOffset
280:    BottomMargin = (Printer.Height - BottomMarginWidth) - TopOffset
   
   ' Calculate the line width
283:    PrintableHeight = BottomMargin - TopMargin
    
   
   ' Create an hDC on the Printer pointed to by the Printer object
   ' This DC needs to remain for the RTF to keep up the WYSIWYG display
288:    PrinterhDC = CreateDC(Printer.DriverName, Printer.DeviceName, 0, 0)

   ' Tell the RTF to base it's display off of the printer
   '    at the desired line width
292:    r = SendMessage(RTF.hWnd, EM_SETTARGETDEVICE, PrinterhDC, _
      ByVal PrintableWidth)

  Exit Sub
ErrorHandler:
  HandleError True, "WYSIWYG_RTF " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' PrintRTF - Prints the contents of a RichTextBox control using the
'            provided margins
'
' RTF - A RichTextBox control to print
'
' LeftMarginWidth - Width of desired left margin in twips
'
' TopMarginHeight - Height of desired top margin in twips
'
' RightMarginWidth - Width of desired right margin in twips
'
' BottomMarginHeight - Height of desired bottom margin in twips
'
' Notes - If you are also using WYSIWYG_RTF() on the provided RTF
'         parameter you should specify the same LeftMarginWidth and
'         RightMarginWidth that you used to call WYSIWYG_RTF()
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub PrintRTF(RTF As RichTextBox, LeftMarginWidth As Long, _
   TopMarginHeight, RightMarginWidth, BottomMarginHeight)
  On Error GoTo ErrorHandler

   Dim LeftOffset As Long, TopOffset As Long
   Dim LeftMargin As Long, TopMargin As Long
   Dim RightMargin As Long, BottomMargin As Long
   Dim fr As FormatRange
   Dim rcDrawTo As RECT
   Dim rcPage As RECT
   Dim TextLength As Long
   Dim NextCharPosition As Long
   Dim r As Long

   ' Start a print job to get a valid Printer.hDC
334:    Printer.Print Space(1)
335:    Printer.ScaleMode = vbTwips

   ' Get the offsett to the printable area on the page in twips
338:    LeftOffset = Printer.ScaleX(GetDeviceCaps(Printer.hdc, _
      PHYSICALOFFSETX), vbPixels, vbTwips)
340:    TopOffset = Printer.ScaleY(GetDeviceCaps(Printer.hdc, _
      PHYSICALOFFSETY), vbPixels, vbTwips)

   ' Calculate the Left, Top, Right, and Bottom margins
344:    LeftMargin = LeftMarginWidth - LeftOffset
345:    TopMargin = TopMarginHeight - TopOffset
346:    RightMargin = (Printer.Width - RightMarginWidth) - LeftOffset
347:    BottomMargin = (Printer.Height - BottomMarginHeight) - TopOffset

   ' Set printable area rect
350:    rcPage.Left = 0
351:    rcPage.Top = 0
352:    rcPage.Right = Printer.ScaleWidth
353:    rcPage.Bottom = Printer.ScaleHeight

   ' Set rect in which to print (relative to printable area)
356:    rcDrawTo.Left = LeftMargin
357:    rcDrawTo.Top = TopMargin
358:    rcDrawTo.Right = RightMargin
359:    rcDrawTo.Bottom = BottomMargin

   ' Set up the print instructions
362:    fr.hdc = Printer.hdc   ' Use the same DC for measuring and rendering
363:    fr.hdcTarget = Printer.hdc  ' Point at printer hDC
364:    fr.rc = rcDrawTo            ' Indicate the area on page to draw to
365:    fr.rcPage = rcPage          ' Indicate entire size of page
366:    fr.chrg.cpMin = 0           ' Indicate start of text through
367:    fr.chrg.cpMax = -1          ' end of the text

   ' Get length of text in RTF
370:    TextLength = Len(RTF.Text)

   ' Loop printing each page until done
373:    Do
      ' Print the page by sending EM_FORMATRANGE message
375:       NextCharPosition = SendMessage(RTF.hWnd, EM_FORMATRANGE, True, fr)
376:       If NextCharPosition >= TextLength Then Exit Do  'If done then exit
377:       fr.chrg.cpMin = NextCharPosition ' Starting position for next page
378:       Printer.NewPage                  ' Move on to next page
379:       Printer.Print Space(1) ' Re-initialize hDC
380:       fr.hdc = Printer.hdc
381:       fr.hdcTarget = Printer.hdc
382:    Loop

   ' Commit the print job
385:    Printer.EndDoc

   ' Allow the RTF to free up memory
388:    r = SendMessage(RTF.hWnd, EM_FORMATRANGE, False, ByVal CLng(0))

  Exit Sub
ErrorHandler:
  HandleError True, "PrintRTF " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub SampleCode()
  On Error GoTo ErrorHandler

  
  Dim strTitle As String
  Dim strReport As String
  Dim strReportRTF As String
  
403:   strTitle = "Sample Title"
404:   strReport = "Sample Report"
405:   strReportRTF = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fprq2\fcharset0 Calibri;}{\f1\fswiss\fcharset0 Arial;}}" & vbNewLine & _
    "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\qc\b\i\f0\fs20 Sample RTF Report\b0\i0\f1\par" & vbNewLine & _
    "}"

  Dim frmReportForm As Brad_Convert.frmReportDialog
410:   Set frmReportForm = New Brad_Convert.frmReportDialog
  
  ' SHOW NORMAL TEXT REPORT
413:   frmReportForm.txtReport.Text = strReport
414:   frmReportForm.txtReport.Locked = False
415:   frmReportForm.Caption = strTitle
416:   frmReportForm.Show vbModal
  
  ' SHOW RTF TEXT REPORT
419:   frmReportForm.txtReport.TextRTF = strReportRTF
420:   frmReportForm.txtReport.Locked = False
421:   frmReportForm.Caption = strTitle
422:   frmReportForm.Show vbModal
  
424:   Set frmReportForm = Nothing


  Exit Sub
ErrorHandler:
  HandleError True, "SampleCode " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


