VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsExtension"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_booShouldContinue As Boolean
Private m_strFolderPath As String
Private m_strDirPath As String
Private m_pfrmRasterExportLayerIDReturn As esriSystem.IVariantArray
Private m_pfrmCircuitscapeLayerIDReturn As esriSystem.IVariantArray
Private m_strDirType As String
Private m_booIsFeatDataset As Boolean
Private m_strFeatDatasetName As String
  
Private m_WildlandPolygon1 As IPolygon
Private m_WildlandPolygon2 As IPolygon
Private m_Corridor As IPolygon
Private m_pfrmClassDefinitionReturn As esriSystem.IVariantArray
Private m_pfrmCrosstabInputReturn As esriSystem.IVariantArray

Private m_EnableSelTool As Boolean
Private m_EnableDrawTool As Boolean
Private m_CorrPolygonIsDrawn As Boolean
Private m_SelForm As Object

Private m_lngVersion As Long
Private m_booClipLayers As Boolean

Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\Brad_Convert\clsExtension.cls"
Implements IExtension
Implements IPersistVariant

' SET FOLLOWING PROPERTIES
Public Property Let RasterExportClip(booShouldClipToPolygon As Boolean)
32:   m_booClipLayers = booShouldClipToPolygon
End Property
Public Property Get RasterExportClip() As Boolean
35:   RasterExportClip = m_booClipLayers
End Property

Public Property Set frmRasterExportLayerIDReturn(pfrmRasterExportLayerIDReturn As esriSystem.IVariantArray)
39:   Set m_pfrmRasterExportLayerIDReturn = pfrmRasterExportLayerIDReturn
End Property

Public Property Get frmRasterExportLayerIDReturn() As esriSystem.IVariantArray
43:   Set frmRasterExportLayerIDReturn = m_pfrmRasterExportLayerIDReturn
End Property
Public Property Set frmCircuitscapeLayerIDReturn(pfrmCircuitscapeLayerIDReturn As esriSystem.IVariantArray)
46:   Set m_pfrmCircuitscapeLayerIDReturn = pfrmCircuitscapeLayerIDReturn
End Property

Public Property Get frmCircuitscapeLayerIDReturn() As esriSystem.IVariantArray
50:   Set frmCircuitscapeLayerIDReturn = m_pfrmCircuitscapeLayerIDReturn
End Property
Public Property Let FeatDatasetName(strFeatDatasetName As String)
53:   m_strFeatDatasetName = strFeatDatasetName
End Property
Public Property Get FeatDatasetName() As String
56:   FeatDatasetName = m_strFeatDatasetName
End Property
Public Property Let IsFeatureDataset(booIsFeatDataset As Boolean)
59:   m_booIsFeatDataset = booIsFeatDataset
End Property
Public Property Get IsFeatureDataset() As Boolean
62:   IsFeatureDataset = m_booIsFeatDataset
End Property
Public Property Let DirectoryType(strDirType As String)
65:   m_strDirType = strDirType
End Property
Public Property Get DirectoryType() As String
68:   DirectoryType = m_strDirType
End Property


Public Property Let DirectoryPath(strPath As String)
  On Error GoTo ErrorHandler
74:   m_strDirPath = strPath
  Exit Property
ErrorHandler:
  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get DirectoryPath() As String
  On Error GoTo ErrorHandler
82:   DirectoryPath = m_strDirPath
  Exit Property
ErrorHandler:
  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get aSelForm() As Object                      ' FOR frmSelScreen
  On Error GoTo ErrorHandler

91:   Set aSelForm = m_SelForm

  Exit Property
ErrorHandler:
  HandleError True, "aSelForm " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set aSelForm(ByRef vNewValue As Object)       ' FOR frmSelScreen
  On Error GoTo ErrorHandler

101:   Set m_SelForm = vNewValue

  Exit Property
ErrorHandler:
  HandleError True, "aSelForm " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let CorrPolygonIsDrawn(booIsDrawn As Boolean)            ' FOR frmClip; FLAG TO INDICATE IF POLYGON WAS HAND-DRAWN
  On Error GoTo ErrorHandler

110:   Let m_CorrPolygonIsDrawn = booIsDrawn

  Exit Property
ErrorHandler:
  HandleError True, "CorrPolygonIsDrawn " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get CorrPolygonIsDrawn() As Boolean                       ' FOR frmClip; FLAG TO INDICATE IF POLYGON WAS HAND-DRAWN
  On Error GoTo ErrorHandler

119:   CorrPolygonIsDrawn = m_CorrPolygonIsDrawn

  Exit Property
ErrorHandler:
  HandleError True, "CorrPolygonIsDrawn " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let EnableSelTool(ShouldEnable As Boolean)    ' FOR frmSelScreen.lbxThemes and imgToolDisable, In, Out
  On Error GoTo ErrorHandler

128:   m_EnableSelTool = ShouldEnable
  

  Exit Property
ErrorHandler:
  HandleError True, "EnableSelTool " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get EnableSelTool() As Boolean                ' FOR frmSelScreen.lbxThemes and imgToolDisable, In, Out
  On Error GoTo ErrorHandler

139:   EnableSelTool = m_EnableSelTool
  

  Exit Property
ErrorHandler:
  HandleError True, "EnableSelTool " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property


Public Property Let EnableDrawTool(ShouldEnable As Boolean)    ' FOR frmSelScreen.lbxThemes and imgToolDisable, In, Out
  On Error GoTo ErrorHandler

151:   m_EnableDrawTool = ShouldEnable
  
  Exit Property
ErrorHandler:
  HandleError True, "EnableDrawTool " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get EnableDrawTool() As Boolean                ' FOR frmSelScreen.lbxThemes and imgToolDisable, In, Out
  On Error GoTo ErrorHandler

161:   EnableDrawTool = m_EnableDrawTool
  

  Exit Property
ErrorHandler:
  HandleError True, "EnableDrawTool " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get PolyWildland1() As IPolygon               ' FOR Jennessent_CompareParameters.imgCheckWB1, cbxHab1
  On Error GoTo ErrorHandler

172:   Set PolyWildland1 = m_WildlandPolygon1

  Exit Property
ErrorHandler:
  HandleError True, "PolyWildland1 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set PolyWildland1(ByRef pPolygon As IPolygon) ' FOR Jennessent_CompareParameters.imgCheckWB1, cbxHab1
  On Error GoTo ErrorHandler

182:   Set m_WildlandPolygon1 = pPolygon

  Exit Property
ErrorHandler:
  HandleError True, "PolyWildland1 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get PolyWildland2() As IPolygon               ' FOR Jennessent_CompareParameters.imgCheckWB2, cbxHab2
  On Error GoTo ErrorHandler

192:   Set PolyWildland2 = m_WildlandPolygon2

  Exit Property
ErrorHandler:
  HandleError True, "PolyWildland2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set PolyWildland2(ByRef pPolygon As IPolygon) ' FOR Jennessent_CompareParameters.imgCheckWB2, cbxHab2
  On Error GoTo ErrorHandler

202:   Set m_WildlandPolygon2 = pPolygon

  Exit Property
ErrorHandler:
  HandleError True, "PolyWildland2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get PolyCorridor() As IPolygon                ' FOR Jennessent_CompareParameters.imgCheckSpCorr, cbxCorridor
  On Error GoTo ErrorHandler

212:   Set PolyCorridor = m_Corridor

  Exit Property
ErrorHandler:
  HandleError True, "PolyCorridor " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set PolyCorridor(ByRef pPolygon As IPolygon)  ' FOR Jennessent_CompareParameters.imgCheckSpCorr, cbxCorridor
  On Error GoTo ErrorHandler
  
222:   Set m_Corridor = pPolygon

  Exit Property
ErrorHandler:
  HandleError True, "PolyCorridor " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get frmStep1() As Object                      ' FOR Jennessent_CompareParameters
  On Error GoTo ErrorHandler

232:   Set frmStep1 = Nothing

  Exit Property
ErrorHandler:
  HandleError True, "frmStep1 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set frmStep1(ByRef frm1 As Object)            ' FOR Jennessent_CompareParameters
  On Error GoTo ErrorHandler

'  Set m_FormStep1 = frm1

  Exit Property
ErrorHandler:
  HandleError True, "frmStep1 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get BottleneckForm() As Object                      ' FOR frmBottleneck
  On Error GoTo ErrorHandler

252:   Set BottleneckForm = Nothing

  Exit Property
ErrorHandler:
  HandleError True, "BottleneckForm " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set BottleneckForm(ByRef frm1 As Object)            ' FOR frmBottleneck
  On Error GoTo ErrorHandler

 ' Set m_frmBottleneck = frm1

  Exit Property
ErrorHandler:
  HandleError True, "BottleneckForm " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get frmClipForm() As Object                      ' FOR frmClip
  On Error GoTo ErrorHandler

271:   Set frmClipForm = Nothing

  Exit Property
ErrorHandler:
  HandleError True, "frmClipForm " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set frmClipForm(ByRef frm1 As Object)            ' FOR frmClip
  On Error GoTo ErrorHandler

'  Set m_ClipForm = frm1

  Exit Property
ErrorHandler:
  HandleError True, "frmClipForm " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let Folder_Export_Location(strFolderPath As String)
  On Error GoTo ErrorHandler
290:   m_strFolderPath = strFolderPath
  Exit Property
ErrorHandler:
  HandleError True, "Folder_Export_Location " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get Folder_Export_Location() As String
  On Error GoTo ErrorHandler
298:   Folder_Export_Location = m_strFolderPath
  Exit Property
ErrorHandler:
  HandleError True, "Folder_Export_Location " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property


Public Property Let ShouldContinue(booShouldContinue As Boolean)
  On Error GoTo ErrorHandler
307:   m_booShouldContinue = booShouldContinue
  Exit Property
ErrorHandler:
  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get ShouldContinue() As Boolean
  On Error GoTo ErrorHandler
315:   ShouldContinue = m_booShouldContinue
  Exit Property
ErrorHandler:
  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Private Property Get IExtension_Name() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
325:   IExtension_Name = "Brad_Export"
  
  Exit Property
ErrorHandler:
  HandleError True, "IExtension_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub IExtension_Startup(ByRef initializationData As Variant)
  On Error GoTo ErrorHandler
  
335:     If m_strDirPath = "" Or m_strDirType = "" Then
336:       m_strDirType = "Shapefile"
337:       m_strDirPath = ""
338:       m_booIsFeatDataset = False
339:       m_strFeatDatasetName = ""
340:     End If
  
  Exit Sub
ErrorHandler:
  HandleError True, "IExtension_Startup " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub IExtension_Shutdown()
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
351:   Set m_pfrmRasterExportLayerIDReturn = Nothing
352:   Set m_pfrmCircuitscapeLayerIDReturn = Nothing
  
  Exit Sub
ErrorHandler:
  HandleError True, "IExtension_Shutdown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Property Get IPersistVariant_ID() As esriSystem.IUID
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  ' IPersistVariant_ID =
  
  Exit Property
ErrorHandler:
  HandleError True, "IPersistVariant_ID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub IPersistVariant_Load(ByVal Stream As esriSystem.IVariantStream)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
375:   m_lngVersion = Stream.Read
376:   m_strFolderPath = Stream.Read
377:   m_booClipLayers = Stream.Read
  
  Exit Sub
ErrorHandler:
  HandleError True, "IPersistVariant_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub IPersistVariant_Save(ByVal Stream As esriSystem.IVariantStream)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
388:   Stream.Write 1      ' Version:  m_lngVersion
389:   Stream.Write m_strFolderPath
390:   Stream.Write m_booClipLayers
  
  Exit Sub
ErrorHandler:
  HandleError True, "IPersistVariant_Save " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


